﻿namespace UltraGridCellCollSpan
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private int rows;
        private int cols;

        public Form1()
        {
            this.InitializeComponent();
            this.uiElementViewerDialog1.Show();
            this.rows = 1000;
            this.cols = 4;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.SetDataBinding(this.GetData(this.rows, this.cols), null);
            this.ultraGrid1.CreationFilter = new MyCreationFilter();
            this.ultraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.Edit;
        }
        
        private object GetData(int rows, int cols)
        {
            DataTable dt = new DataTable();

            for (int col = 0; col < cols; col++)
            {
                dt.Columns.Add(string.Format("Column #{0}", col + 1));
            }

            for (int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach (DataColumn column in dt.Columns)
                {
                    addRow[column] = string.Format("{0}.{1}", row + 1, column.Ordinal + 1);
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }
    }
}
