﻿namespace UltraGridCellCollSpan
{
    using System.Drawing;
    using System.Linq;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    internal class MyCreationFilter : IUIElementCreationFilter
    {
        private int newWidth;

        private int GetNewWidth(int oldWidth)
        {
            if (this.newWidth == 0)
            {
                this.newWidth = oldWidth * 2 + 3;
            }

            return this.newWidth;
        }
        public void AfterCreateChildElements(UIElement parent)
        {
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            CellUIElement cellElement = parent as CellUIElement;

            if (cellElement != null)
            {
                UltraGridCell cell = cellElement.GetContext(typeof(UltraGridCell)) as UltraGridCell;
                int cellColIndex = cell.Column.Index;

                if (cell.Text.Contains("*"))
                {
                    if (cellColIndex != cell.Row.Cells.Count - 1)
                    {
                        int newWidth = this.GetNewWidth(cellElement.Rect.Width);
                        int height = cellElement.Rect.Height;
                        cellElement.Rect = new Rectangle(cellElement.Rect.X, cellElement.Rect.Y, newWidth, height);
                    } 
                }


                if (cellColIndex != 0)
                {
                    if (cell.Row.Cells[cellColIndex-1].Text.Contains("*"))
                    {
                        cellElement.Parent.ChildElements.Remove(cellElement);
                    }
                }
            }

            return false;
        }
    }
}